;**********************************************************
; Vertical Scroll Demo
; S. Orchard
;**********************************************************
;
; Scroll up or down
;
;**********************************************************

	section "CODE"

;*************************************
; move up
;*************************************

td_scroll_up

	; buffer pointer 1 line up
	ldd td_bptr
	subd #32
	bhs 1f
	addd #TD_SBSIZE
1	std td_bptr


	; if moving into new tile then move map pointer up
	lda td_vcoord
	bita #15
	lbne 1f

	ldd td_mptr
	subd #MAPWID
	cmpd #MAPSTART
	bhs 2f
	addd #MAPSIZE
2	std td_mptr

	
	; get address of tile data
	lda td_vcoord
1	suba #1
	sta td_vcoord
	ldu #TILES
	anda #15
	lsla
	leau a,u

	; position to start drawing
	ldx td_bptr
	leax TD_SBUFF,x
	
	; map row
	ldy td_mptr

	bra td_draw_ud

	
;*************************************
; move down
;*************************************

td_scroll_down

	; buffer pointer 1 line down
	ldd td_bptr
	addd #32
	cmpd #TD_SBSIZE
	blo 1f
	subd #TD_SBSIZE
1	std td_bptr

	; if moving into new tile then move map pointer down
	lda td_vcoord
	adda #1
	sta td_vcoord
	bita #15
	lbne 1f

	ldx td_mptr
	leax MAPWID,x
	cmpx #MAPEND
	blo 2f
	leax -MAPSIZE,x
2	stx td_mptr

	
	; get address of tile data
	lda td_vcoord
1	ldu #TILES
	adda #15
	anda #15
	lsla
	leau a,u

	; position to start drawing
2	ldx td_bptr
	leax TD_SBSIZE-32,x
	cmpx #TD_SBSIZE
	blo 1f
	leax -TD_SBSIZE,x
1	leax TD_SBUFF,x

	; map row
	ldy td_mptr
	leay TD_TILEROWS*MAPWID,y
	lda td_vcoord
	bita #15
	bne 1f
	leay -MAPWID,y	; adjust if drawing last row of tile
1	cmpy #MAPEND
	blo 1f
	leay -MAPSIZE,y
1
	;fall through to td_draw_ud

;*************************************

td_draw_ud

	lda #16
	sta td_count
2	lda ,y+
	ldb #32
	mul
	ldd d,u
	std ,x++
1	dec td_count
	bne 2b

	rts

