;**********************************************************
; Vertical Scroll Demo
; S. Orchard
;
; Assemble with asm6809  (www.6809.org.uk)
; asm6809 -D -o vsdemo.bin vsdemo.asm 
;
;**********************************************************



GMODE	equ $f8 ;$e0
	
;**********************************************************

	section "DPVARS"

	org $3f00

DPVARS

frmflag			rmb 1

;**********************************************************

; display frame buffers
FBUF0	equ $0400
FBUF1	equ FBUF0+$1800


FRAME0 macro
	;sta $ffc9	; 1K on
	sta $ffca	; 2K off
	sta $ffcc	; 4K off
	endm

FRAME1 macro
	;sta $ffc9	; 1K on
	sta $ffcb	; 2K on
	sta $ffcd	; 4K on
	endm

;**********************************************************

	section "CODE"

	org $4000
 
	orcc #$50

	lds #$400
	
	lda #DPVARS >> 8
	tfr a,dp
	setdp DPVARS >> 8

	jsr td_init

	
	ldd #$0000
	ldx #TD_SBUFF
1	std ,x++
	cmpx #TD_SBEND
	blo 1b

	clr td_fbuf+1
	clr frmflag
	jsr flip_frame_buffers

	lda $ff03	; disable fs irq
	anda #$fe	;
	sta $ff03	;
	lda $ff02	;

	lda #GMODE
	sta $ff22
    sta $ffc3
    sta $ffc5
	
;-------------------------

MLOOP 
	jsr flip_frame_buffers

	;jsr td_scroll_up
	jsr td_scroll_down

	; copy background to frame buffer
	jsr td_copybuf

	bra MLOOP
	
;*************************************


;*************************************
; Swap front and back frame buffers
;*************************************

flip_frame_buffers
  	lda $ff02	; clear fs flag
1	lda $ff03	; wait for fs
	bpl 1b		;
	com frmflag
	beq 90f
	lda #FBUF0 >> 8
	sta td_fbuf
	FRAME1
	rts
90	lda #FBUF1 >> 8
	sta td_fbuf
	FRAME0
	rts
	
;*************************************

	include "tiledata.asm"

;**********************************************************

TD_TILEROWS	equ 9	; number of rows of tiles

	include "tiledriver.asm"

;**********************************************************
	
	section "CODE"
__end_code		org *

	section "DPVARS"
__end_dpvars	org *

	section "DATA"
__end_data		org *

	
